// DEMO9_3.CPP - DirectInput Joystick Demo

// INCLUDES ///////////////////////////////////////////////

#define WIN32_LEAN_AND_MEAN  

#define INITGUID // if not done elsewhere

#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <objbase.h>
#include <iostream.h> // include important C/C++ stuff
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h> 
#include <math.h>
#include <io.h>
#include <fcntl.h>

#define GAME_H
#include <ddraw.h>     // directX includes
#include <dinput.h>
#include <dsound.h>
#include <dmksctrl.h>
#include <dmusici.h>
#include <dmusicc.h>
#include <dmusicf.h>

#include "T3DLIB1.H"
#include "T3DLIB2.H"
#include "T3DLIB3.H"
#include "Game.h"
#include <vector>
#include <fstream>
// DEFINES ////////////////////////////////////////////////

//RW GLOBALS////////////////////////////////////////////////
std::ofstream ErrorLog;

char buffer_score[30];
int gScore =0;
int buffer_hundred[30];
char buffer_actpos[80];
char buffer_targetpos[80];
char buffer2_actpos[80];
char buffer2_targetpos[80];

char buffer3[80];

void InitializeLevel(LEVEL currentLevel);
bool RunLevel(LEVEL currentLevel);
void ResetLevel(LEVEL currentLevel);
inline void DrawInViewPort(BOB* bob_ptr, int x_offset);

static BITMAP_IMAGE_PTR BackgrndImagePtr;
BOB* pLevelBackground;

DWORD PauseScreenTimer;
DWORD bob1_StartTime;
DWORD bob2_StartTime;
bool bResetScreenTimer = true;
bool bResetTimer_bob1 = true;
bool bResetTimer_bob2 = true;


static int x_offset = 0;
static int x_PreviosOffset = 0;

int gLifeLine = 2;
int gPreviousLifeLine = 2;
// FUNCTIONS /////////////////////////////////////////////////

LRESULT CALLBACK WindowProc(HWND hwnd, 
						    UINT msg, 
                            WPARAM wparam, 
                            LPARAM lparam)
{
// this is the main message handler of the system
PAINTSTRUCT		ps;		// used in WM_PAINT
HDC				hdc;	// handle to a device context
char buffer[80];        // used to print strings

// what is the message 
switch(msg)
	{	
	case WM_CREATE: 
        {
		// do initialization stuff here
        // return success
		return(0);
		} break;
   
	case WM_PAINT: 
		{
		// simply validate the window 
   	    hdc = BeginPaint(hwnd,&ps);	 
        
        // end painting
        EndPaint(hwnd,&ps);

        // return success
		return(0);
   		} break;

	case WM_DESTROY: 
		{

		// kill the application, this sends a WM_QUIT message 
		PostQuitMessage(0);

        // return success
		return(0);
		} break;

	default:break;

    } // end switch

// process any messages that we didn't take care of 
return (DefWindowProc(hwnd, msg, wparam, lparam));

} // end WinProc

// WINMAIN ////////////////////////////////////////////////

int WINAPI WinMain(	HINSTANCE hinstance,
					HINSTANCE hprevinstance,
					LPSTR lpcmdline,
					int ncmdshow)
{

WNDCLASSEX winclass; // this will hold the class we create
HWND	   hwnd;	 // generic window handle
MSG		   msg;		 // generic message
HDC        hdc;      // graphics device context

// first fill in the window class stucture
winclass.cbSize         = sizeof(WNDCLASSEX);
winclass.style			= CS_DBLCLKS | CS_OWNDC | 
                          CS_HREDRAW | CS_VREDRAW;
winclass.lpfnWndProc	= WindowProc;
winclass.cbClsExtra		= 0;
winclass.cbWndExtra		= 0;
winclass.hInstance		= hinstance;
winclass.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
winclass.hCursor		= LoadCursor(NULL, IDC_ARROW); 
winclass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
winclass.lpszMenuName	= NULL;
winclass.lpszClassName	= WINDOW_CLASS_NAME;
winclass.hIconSm        = LoadIcon(NULL, IDI_APPLICATION);

// save hinstance in global
main_instance = hinstance;



ErrorLog.open("ErrorLog.txt");






// register the window class
if (!RegisterClassEx(&winclass))
	return(0);

// create the window
if (!(hwnd = CreateWindowEx(NULL,                  // extended style
                            WINDOW_CLASS_NAME,     // class
						    "DirectInput Joystick Demo", // title
							(WINDOWED_APP? (WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION): (WS_POPUP | WS_VISIBLE)),
					 	    0,0,	  // initial x,y
						    SCREEN_WIDTH,SCREEN_HEIGHT,  // initial width, height
						    NULL,	  // handle to parent 
						    NULL,	  // handle to menu
						    hinstance,// instance of this application
						    NULL)))	// extra creation parms
return(0);

// save main window handle
main_window_handle = hwnd;



if (WINDOWED_APP)
{
// now resize the window, so the client area is the actual size requested
// since there may be borders and controls if this is going to be a windowed app
// if the app is not windowed then it won't matter
RECT window_rect = {0,0,SCREEN_WIDTH-1,SCREEN_HEIGHT-1};

// make the call to adjust window_rect
AdjustWindowRectEx(&window_rect,
     GetWindowStyle(main_window_handle),
     GetMenu(main_window_handle) != NULL,
     GetWindowExStyle(main_window_handle));

// save the global client offsets, they are needed in DDraw_Flip()
window_client_x0 = -window_rect.left;
window_client_y0 = -window_rect.top;

// now resize the window with a call to MoveWindow()
MoveWindow(main_window_handle,
           0, // x position
           0, // y position
           window_rect.right - window_rect.left, // width
           window_rect.bottom - window_rect.top, // height
           TRUE);

// show the window, so there's no garbage on first render
ShowWindow(main_window_handle, SW_SHOW);
} // end if windowed

// initialize game here
Game_Init();

// enter main event loop
while(TRUE)
	{
    // test if there is a message in queue, if so get it
	if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
	   { 
	   // test if this is a quit
       if (msg.message == WM_QUIT)
           break;
	
	   // translate any accelerator keys
	   TranslateMessage(&msg);

	   // send the message to the window proc
	   DispatchMessage(&msg);
	   } // end if
    
       // main game processing goes here
       Game_Main();
       
	} // end while

// closedown game here
Game_Shutdown();

// return to Windows like this
return(msg.wParam);

} // end WinMain

////////////////////////////////////////////////////////////////////

BOOL CALLBACK DI_Enum_Joysticks(LPCDIDEVICEINSTANCE lpddi,
								LPVOID guid_ptr) 
{
// this function enumerates the joysticks, but
// stops at the first one and returns the
// instance guid of it, so we can create it

*(GUID*)guid_ptr = lpddi->guidInstance; 

// copy name into global
strcpy(joyname, (char *)lpddi->tszProductName);

// stop enumeration after one iteration
return(DIENUM_STOP);

} // end DI_Enum_Joysticks

///////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////

int Game_Main(void *parms, int num_parms)
{
// this is the workhorse of your game it will be called
// continuously in real-time this is like main() in C
// all the calls for you game go here!

int          index;             // looping var
int          dx,dy;             // general deltas used in collision detection
static LEVEL level = MAIN_MENU;



// check of user is trying to exit
if (KEY_DOWN(VK_ESCAPE) || KEY_DOWN(VK_SPACE))
    PostMessage(main_window_handle, WM_DESTROY,0,0);

// start the timing clock
Start_Clock();

// clear the drawing surface
DDraw_Fill_Surface(lpddsback, 0);

// get joystick data
lpdijoy->Poll(); // this is needed for joysticks only
lpdijoy->GetDeviceState(sizeof(DIJOYSTATE), (LPVOID)&joy_state);


static bool MainMenuInitialized = false;
if (MainMenuInitialized == false)
	{
	InitializeLevel(MAIN_MENU);
	MainMenuInitialized = true;
	}


if (RunLevel(level) == true )
	{
	level= LEVEL(level+1);
	}

if (level == CREDITS)
	level = MAIN_MENU;

// flip the surfaces
DDraw_Flip();

// sync to 30 fps
Wait_Clock(30);

// return success
return(1);

} // end Game_Main

//////////////////////////////////////////////////////////



void InitializeLevel(LEVEL currentLevel)
{	
	switch (eLevel)
		{
		/***********************************
		*MAIN MENU
		***********************************/
		case MAIN_MENU:
			{
			BackgrndImagePtr = &Intro_Text_AjMax;
			// clear out buffers
			DDraw_Fill_Surface(lpddsback, 0);
			DDraw_Fill_Surface(lpddsprimary, 0);
			Create_Bitmap(&Intro_Text_AjMax,0,0,SCREEN_WIDTH,SCREEN_HEIGHT, SCREEN_BPP);
			Intro_Text_AjMax.attr |= BITMAP_ATTR_LOADED;

			// fill in the background
//			Load_Bitmap_File(&bitmap16bit, "IntroBackground.bmp");
			Load_Bitmap_File(&bitmap16bit, "Intro_Terrain.bmp");

			// load the introductory background image
			Load_Image_Bitmap16(&Intro_Text_AjMax,&bitmap16bit,0,0,BITMAP_EXTRACT_MODE_ABS);
			Unload_Bitmap_File(&bitmap16bit);
			// load the graphics for the start exit text
			Load_Bitmap_File(&bitmap16bit, "StartExit.bmp");		//load image into memory

			// now create the bob
			Create_BOB(&bobStartExit,0,0,118,50,2,
					BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM/*| BOB_ATTR_ANIM_ONE_SHOT*/,
					DDSCAPS_SYSTEMMEMORY, 0, 16);
			
			// load in the frames of the start exit text image
			for (int index=0; index<2; index++)
				{
				Load_Frame_BOB16(&bobStartExit,&bitmap16bit,index,index,0,BITMAP_EXTRACT_MODE_CELL);  //extract images from bitmap file and load into bob struct
				}	

			Unload_Bitmap_File(&bitmap16bit);

			Set_Pos_BOB(&bobStartExit,270,244);

			Load_Animation_BOB(&bobStartExit,0,2,startExit_anim);
			}
			break; //end case MAIN_MENU

		/*************************
		*	LEVEL 1
		*************************/
		case LEVEL1:
			{
			bat1.state = BOB_STATE_ALIVE;
			bat2.state = BOB_STATE_ALIVE;

			
			Set_Pos_BOB(&baby1,50,90);


			apple1.xv = 0;		apple1.yv = 0;		apple1.x = 100;		apple1.y = 440;		apple1.weapon_stat = WEAPON_AVAILABLE;	
			apple2.xv = 0;		apple2.yv = 0;		apple2.x = 100;		apple2.y = 330;		apple2.weapon_stat = WEAPON_AVAILABLE;			
			apple3.xv = 0;		apple3.yv = 0;		apple3.x = 100;		apple3.y = 220;		apple3.weapon_stat = WEAPON_AVAILABLE;			
			apple4.xv = 0;		apple4.yv = 0;		apple4.x = 100;		apple4.y = 110;		apple4.weapon_stat = WEAPON_AVAILABLE;			
			apple5.xv = 0;		apple5.yv = 0;		apple5.x = 540;		apple5.y = 440;		apple5.weapon_stat = WEAPON_AVAILABLE;			
			apple6.xv = 0;		apple6.yv = 0;		apple6.x = 540;		apple6.y = 330;		apple6.weapon_stat = WEAPON_AVAILABLE;			
			apple7.xv = 0;		apple7.yv = 0;		apple7.x = 540;		apple7.y = 220;		apple7.weapon_stat = WEAPON_AVAILABLE;			
			apple8.xv = 0;		apple8.yv = 0;		apple8.x = 540;		apple8.y = 110;		apple8.weapon_stat = WEAPON_AVAILABLE;			

			for (std::vector<BOB*>::iterator i = vpSt_L1_Weapons.begin(); i != vpSt_L1_Weapons.end(); i++)
				{
				(*i)->weapon_stat = WEAPON_AVAILABLE;
				}

			vActiveProjectile.clear();
			vBabyChain.clear();
			vpSt_L1_FreeBabies.push_back(aLevel1_babies[0]);


			}
			break;

		/*************************
		*	LEVEL 2
		*************************/
		case LEVEL2:
			{

			}
			break;

		/*********************************
		*	LEVEL GAME OVER SPLASH SCREEN
		*********************************/
		case GAME_OVER:
			{

			}
			break;

		/*************************
		*	CONGRATULATIONS
		*************************/
		case CONGRATULATIONS:
			{

			}
			break;

		/*************************
		*	CREDITS
		*************************/
		case CREDITS:
			{

			}
			break;

		default:
			break;
		}

	return;
}


bool RunLevel(LEVEL currentLevel)
{
	bool functionComplete = false;

	switch (currentLevel)
	{
	case MAIN_MENU:
		{
		gLifeLine = 2;
		gPreviousLifeLine = 2;
		Critter1Ptr = NULL;
		Critter2Ptr = NULL;
		// lock the back buffer
		DDraw_Lock_Back_Surface();

		Draw_Bitmap16(&Intro_Text_AjMax, back_buffer, back_lpitch, 0);

		// unlock the back buffer
		DDraw_Unlock_Back_Surface();

		if (DMusic_Status_MIDI(midi_ids[1]) != MIDI_PLAYING)
		{
			DMusic_Play(midi_ids[1]);
		}

		if (joy_state.lY > 0 && 
			bobStartExit.curr_frame != 1 &&
			DSound_Status_Sound(sound_ids[0]) != DSBSTATUS_PLAYING)
			{
			bobStartExit.curr_frame = 1;
	        DSound_Play(sound_ids[0]);

			}
		if (joy_state.lY < 0 && 
			bobStartExit.curr_frame != 0 &&
			DSound_Status_Sound(sound_ids[0]) != DSBSTATUS_PLAYING)
			{
			bobStartExit.curr_frame = 0;
	        DSound_Play(sound_ids[0]);

			}				
		Draw_BOB16(&bobStartExit,lpddsback);
//sprintf(buffer3, "RemainingLives =%d", int(gLifeLine));
Draw_Text_GDI("Richard Wells", 10, 460,RGB(255,255,50),lpddsback); 

		if(joy_state.rgbButtons[1])
			{
			functionComplete = true;
			}
		}
		break;

	/*************************
	*	LEVEL 1
	*************************/
	case LEVEL1:
		{
			Critter1Ptr = &bat1;
			Critter2Ptr = &bat2;
		//	backgroundImagePtr	= &L1_Bmp_BackGrnd;	
			pLevelBackground = &L1_Bmp_BackGrnd;	

		}
		break;

	/*************************
	*	LEVEL 2
	*************************/
	case LEVEL2:
		{
		return true;
		}
		break;

	/*********************************
	*	LEVEL GAME OVER SPLASH SCREEN
	*********************************/
	case GAME_OVER:
		{
		return true;

		}
		break;

	/*************************
	*	CONGRATULATIONS
	*************************/
	case CONGRATULATIONS:
		{
		static int offset = 0;
		if (offset > SCREEN_WIDTH)
			offset -= SCREEN_WIDTH;

		Draw_BOB16(&clouds,lpddsback, offset);
		Draw_BOB16(&clouds,lpddsback, offset- SCREEN_WIDTH);		//alias

		if (gLifeLine > 0)
			Draw_BOB16(&YouWin,lpddsback);
		else
			Draw_BOB16(&GameOver,lpddsback);

		offset++;
//	ResetLevel(LEVEL1);			//todo don't hard code

		if (bResetScreenTimer)
			{
			PauseScreenTimer = GetTickCount();
			bResetScreenTimer = false;
			}

		if ((GetTickCount() - PauseScreenTimer) > 3000)
			{
			bResetScreenTimer = true;
			return true;
			}
		}	
		break;

	/*************************
	*	CREDITS
	*************************/
	case CREDITS:
		{
		return true;

		}
		break;

	default:
		break;
	}

	if (currentLevel == MAIN_MENU		|| 
		currentLevel == GAME_OVER		||
		currentLevel == CONGRATULATIONS ||
		currentLevel == CONGRATULATIONS ||
		currentLevel == CREDITS				)
		{
		return functionComplete;
		}



/**********************************
DRAW EVERYTHING TO THE BACK BUFFER
**********************************/
//if (


/*********************
DRAW BACKGROUND IMAGE
*********************/
//DDraw_Fill_Surface(lpddsback, 0);
/*backgroundImagePtr->x = x_offset;
	
// lock the back buffer
DDraw_Lock_Back_Surface();

// draw the background reactor image
Draw_Bitmap16(backgroundImagePtr, back_buffer, back_lpitch, 0);

// unlock the back buffer
DDraw_Unlock_Back_Surface();
*/

DrawInViewPort(pLevelBackground, x_offset);

DrawInViewPort(&door, x_offset);
//Is player ready to exit the level
	if (vBabyChain.size() >= LEV1_NUM_BABIES)
		{
		Animate_BOB(&door);
		}



/*
//draw background image alias
if (x_offset > 0)
	{
	backgroundImagePtr->x = SCREEN_WIDTH - x_offset;
	}
else if (x_offset < 0)
	{
	backgroundImagePtr->x = -SCREEN_WIDTH - x_offset;
	}
else
	{
	backgroundImagePtr->x = 0;
	}


// lock the back buffer
DDraw_Lock_Back_Surface();

// draw the background reactor image
Draw_Bitmap16(backgroundImagePtr, back_buffer, back_lpitch, 0);

// unlock the back buffer
DDraw_Unlock_Back_Surface();
*/

Animate_BOB(&explosion);
Animate_BOB(Critter1Ptr);
Animate_BOB(Critter2Ptr);

if(Critter1Ptr->state == BOB_STATE_ALIVE)
//	Draw_BOB16(Critter1Ptr,lpddsback, x_offset);
	DrawInViewPort(Critter1Ptr, x_offset);

if(Critter2Ptr->state == BOB_STATE_ALIVE)
	//Draw_BOB16(Critter2Ptr,lpddsback, x_offset);
	DrawInViewPort(Critter2Ptr, x_offset);


if( explosion.anim_state != BOB_STATE_ANIM_DONE)
	//Draw_BOB16(&explosion,lpddsback, x_offset);
	DrawInViewPort(&explosion, x_offset);

//Draw_BOB16(&Ariana,lpddsback, x_offset);  //optimization calculate size in init function and store to a structure member
DrawInViewPort(&Ariana, x_offset);

for (std::vector<BOB*>::iterator i = vpSt_L1_Weapons.begin(); i != vpSt_L1_Weapons.end(); i++)
	{
	if (  (*i)->weapon_stat != WEAPON_DESTROYED)
		{
		//Draw_BOB16(*i,lpddsback);
		DrawInViewPort(*i, x_offset);
		}
	}

//Draw FreeBabies
for (std::vector<BOB*>::iterator s = vpSt_L1_FreeBabies.begin(); s != vpSt_L1_FreeBabies.end(); s++)
	{
	//Draw_BOB16(*s,lpddsback);
	DrawInViewPort(*s, x_offset);
	}

//Draw Chained Babies
for (std::vector<BOB*>::iterator t = vBabyChain.begin(); t != vBabyChain.end(); t++)
	{
	//Draw_BOB16(*t,lpddsback);
	DrawInViewPort(*t, x_offset);

	}

// draw some text
Draw_Text_GDI("Make My Centipede!",0,0,RGB(255,255,255),lpddsback);


if(cheese1.state == BOB_STATE_ALIVE)
	DrawInViewPort(&cheese1, x_offset);

if(cheese2.state == BOB_STATE_ALIVE)
	DrawInViewPort(&cheese2, x_offset);

if(cheese1.state == BOB_STATE_ALIVE || cheese2.state == BOB_STATE_ALIVE)
	DrawInViewPort(&jail, x_offset);


// display joystick and buttons 0-7
/*sprintf(buffer,"Joystick Stats: X-Axis=%d, Y-Axis=%d, buttons(%d,%d,%d,%d,%d,%d,%d,%d)",
                                                                      joy_state.lX,joy_state.lY,
                                                                      joy_state.rgbButtons[0],
                                                                      joy_state.rgbButtons[1],
                                                                      joy_state.rgbButtons[2],
                                                                      joy_state.rgbButtons[3],
                                                                      joy_state.rgbButtons[4],
                                                                      joy_state.rgbButtons[5],
                                                                      joy_state.rgbButtons[6],
                                                                      joy_state.rgbButtons[7]);
*/
/*sprintf(buffer2_actpos, "Medussa1 postion =%d,%d", int(bat1.x), int (bat1.y));
sprintf(buffer2_targetpos, "Medussa1 Target Position =  %d,%d", vSt_L1_Vertices[bat1.destination].x, vSt_L1_Vertices[bat1.destination].y );
Draw_Text_GDI(buffer2_actpos, 10, 260,RGB(255,255,50),lpddsback); 
Draw_Text_GDI(buffer2_targetpos, 10, 280,RGB(255,255,50),lpddsback); 


sprintf(buffer_actpos, "Medussa2 postion =%d,%d", int(bat2.x), int (bat2.y));
sprintf(buffer_targetpos, "Medussa2 Target Position =  %d,%d", vSt_L1_Vertices[bat2.destination].x, vSt_L1_Vertices[bat2.destination].y );
Draw_Text_GDI(buffer_actpos, 10, 400,RGB(255,255,50),lpddsback); 
Draw_Text_GDI(buffer_targetpos, 10, 430,RGB(255,255,50),lpddsback); 
*/
sprintf(buffer3, "RemainingLives =%d", int(gLifeLine));
Draw_Text_GDI(buffer3, 10, 460,RGB(255,255,50),lpddsback); 


sprintf(buffer_score, "Score = %d", gScore);
Draw_Text_GDI(buffer_score, 500, 460,RGB(255,255,50),lpddsback); 




if(gLifeLine < gPreviousLifeLine)
	{
	gPreviousLifeLine = gLifeLine;
	if (explosion.anim_state = BOB_STATE_ANIM_DONE)
	Wait_Clock(2000);
	ResetLevel(currentLevel);
	}


if(gLifeLine <= 0)
	return true;
/*
Draw_Text_GDI(buffer,0,SCREEN_HEIGHT-20,RGB(255,255,50),lpddsback);

// print out name of joystick
sprintf(buffer, "Joystick Name & Vendor: %s",joyname);
Draw_Text_GDI(buffer,0,SCREEN_HEIGHT-40,RGB(255,255,50),lpddsback);
*/


//Has player completed the level
if (vBabyChain.size() >= 1 && Collision_BOBS(&door, &Ariana))
	{
//	sprintf(buffer_score, "Score = %d", gScore);
//	static int n = 0;
	Draw_Text_GDI("100", vBabyChain[0]->x+x_offset, vBabyChain[0]->y - 20, RGB(255,255,50),lpddsback);  //todo don't hardcode a 0 in the array position
//	n++;
    DSound_Play(sound_ids[2]);
	Wait_Clock(1000);
	
	gScore+=1500;
//	if (n >= 1)
//		{
		ResetLevel(currentLevel);
		return true;
//		}
//	return false;
	}



/*********************
GET PLAYER INPUT
********************/
if (joy_state.lX > 0 || KEY_DOWN(VK_RIGHT))
	{
	if (Ariana.curr_animation != BOB_EAST)
		Set_Animation_BOB(&Ariana, BOB_EAST);

	if (Ariana.xv < MAX_ARIANA_SPEED)
		{
		Ariana.xv+=0.2;
		}
	}
else if (joy_state.lX < 0 || KEY_DOWN(VK_LEFT))
	{
	if (Ariana.curr_animation != BOB_WEST)
		Set_Animation_BOB(&Ariana, BOB_WEST);

	if(Ariana.xv > MIN_ARIANA_SPEED)
		{
		Ariana.xv-=0.2;
		}
	}
else	//account for momentum
	{
	if ( -1 <= Ariana.xv && Ariana.xv <=1)
		{
		Ariana.xv = 0;
		}
	else if (Ariana.xv >= 1)
		{
		Ariana.xv-=0.25;
		}
	else if (Ariana.xv <= -1)
		{
		Ariana.xv+=0.25;
		}
	}

/*******************
IS PLAYER JUMPING
*******************/
if (joy_state.rgbButtons[1] && Ariana.isJumping == false)
	{
//	Ariana.xv = 1;
	Ariana.yv = -7;
	Ariana.isJumping = true;

	}

if (joy_state.lX != 0 )
	{
	Animate_BOB(&Ariana);
	}


/*******************
DOES PLAYER WANT TO SHOOT
*******************/

//Does the player want to shoot the weapon
if (joy_state.rgbButtons[2] && ArianasWeapon != NULL)
	{
	ArianasWeapon->weapon_stat = WEAPON_FIRING;
	if (Ariana.curr_animation == BOB_EAST)
		{
		ArianasWeapon->xv = MAX_PROJECTILE_SPEED;
		}
	else
		{
		ArianasWeapon->xv = MIN_PROJECTILE_SPEED;
		}
	vActiveProjectile.push_back(ArianasWeapon);
	
	ArianasWeapon = NULL;
	}



/*************************
TEST SCREEN BOUNDARY LIMITS
*************************/

//blaster.y+=joy_state.lY;

// test bounds
if (Ariana.x > SCREEN_WIDTH)
    Ariana.x -= SCREEN_WIDTH;
else
if ((Ariana.x+Ariana.width) < 0)
    Ariana.x = SCREEN_WIDTH-Ariana.width;



if ((Critter1Ptr->x) > SCREEN_WIDTH)
    Critter1Ptr->x -= SCREEN_WIDTH;
else
if ((Critter1Ptr->x + Critter1Ptr->width)< 0)
    Critter1Ptr->x = SCREEN_WIDTH-Critter1Ptr->width;



if ((Critter2Ptr->x) > SCREEN_WIDTH)
    Critter2Ptr->x -= SCREEN_WIDTH;
else
if ((Critter2Ptr->x+Critter2Ptr->width) < 0)
    Critter2Ptr->x = SCREEN_WIDTH - Critter2Ptr->width;






/*****************************************************************************
MOVE PLAYER AND CRITTERS (AI, GRAVITY, ETC), CHECK FOR COLLISION WITH TERRAIN
*****************************************************************************/

//PERFORM CRITTER AI
CritterAI(Critter1Ptr, vE_L1_Map, vSt_L1_Vertices);
CritterAI(Critter2Ptr, vE_L1_Map, vSt_L1_Vertices);

//Apply gravity to Critters
if (Critter1Ptr->state == BOB_STATE_ALIVE)
	{
	Critter1Ptr->x += Critter1Ptr->xv;
	Critter1Ptr->yv += CRITTER_GRAVITY;
	Critter1Ptr->y += Critter1Ptr->yv;
	}

if (Critter2Ptr->state == BOB_STATE_ALIVE)
	{
	Critter2Ptr->x += Critter2Ptr->xv;
	Critter2Ptr->yv += CRITTER_GRAVITY;
	Critter2Ptr->y += Critter2Ptr->yv; 
	}

if(Ariana.isJumping == false)
	{
	Ariana.yv = 4;
	}	
Ariana.yv+= GRAVITY;
Ariana.y += Ariana.yv ;
Ariana.x +=Ariana.xv;

x_offset -= Ariana.xv;

if (x_offset >= SCREEN_WIDTH)
	{
	x_offset -= SCREEN_WIDTH;
	}
else if (x_offset <= -SCREEN_WIDTH)
	{
	x_offset += SCREEN_WIDTH;
	}
//ErrorLog<<"Critter1.x " <<Critter1.x << ", Critter1 target " << vSt_L1_Vertices[Critter1.destination].x <<'\n';
//Perform collision checking and collision response.
Collision_Checker(&Ariana, ARIANA_SCALE_FACTOR, vSt_L1_Terrain);
Collision_Checker(Critter1Ptr, MEDUSSA_SCALE_FACTOR, vSt_L1_Terrain);
Collision_Checker(Critter2Ptr, MEDUSSA_SCALE_FACTOR, vSt_L1_Terrain);


//Check try to recover a weapon
WeaponRetrieval(&Ariana, vpSt_L1_Weapons);

if(ArianasWeapon != NULL)
	{
	ArianasWeapon->x = Ariana.x + Ariana.width;
	ArianasWeapon->y = Ariana.y+Ariana.height - ArianasWeapon->height;

	}




/*****************************************************
MOVE PROJECTILES AND CHECK FOR COLLISION WITH CRITTERS
*****************************************************/

//Move the projectiles, set flag for any projectiles that are offscreen
if(vActiveProjectile.size() !=0)
	{
	for (std::vector<BOB*>::iterator i = vActiveProjectile.begin(); i != vActiveProjectile.end(); i++)
		{
		(*i)->x += (*i)->xv;
		if ( (*i)->x > SCREEN_WIDTH || (*i)->x < 0)
			{
			(*i)->weapon_stat = WEAPON_DESTROYED;
			vActiveProjectile.erase(i);							//todo this could cause a problem
			if (i == vActiveProjectile.end())					//patch
				break;
			}
		
		//Check if projectile collides with critter
		if(IsThereABOBCollision(Critter1Ptr, *i))
			{
			Critter1Ptr->state = BOB_STATE_DYING;
			(*i)->weapon_stat = WEAPON_DESTROYED;
			gScore+=500;
			}
		if(IsThereABOBCollision(Critter2Ptr, *i))
			{
			Critter2Ptr->state = BOB_STATE_DYING;
			(*i)->weapon_stat = WEAPON_DESTROYED;
			gScore+=500;
			}
		}

	}

if (Critter1Ptr->state == BOB_STATE_DYING)
	{
	Critter1Ptr->state = BOB_STATE_DEAD;
	explosion.x = Critter1Ptr->x-20;
	explosion.y = Critter1Ptr->y-30;
	explosion.anim_state = 0;
    DSound_Play(sound_ids[1]);

	}
else if (Critter2Ptr->state == BOB_STATE_DYING)
	{
	Critter2Ptr->state = BOB_STATE_DEAD;
	explosion.x = Critter2Ptr->x-20;
	explosion.y = Critter2Ptr->y-30;
	explosion.anim_state = 0;
    DSound_Play(sound_ids[1]);

	}


/**********************
Reactivate critters
***********************/
if (Critter1Ptr->state == BOB_STATE_DEAD)
	{
	if (bResetTimer_bob1)
		{
		bob1_StartTime = GetTickCount();
		bResetTimer_bob1 = false;
		}

	if ((GetTickCount() - bob1_StartTime) > 3000)
		{
		bResetTimer_bob1 = true;
		Critter1Ptr->state = BOB_STATE_ALIVE;
		}
	}


if (Critter2Ptr->state == BOB_STATE_DEAD)
	{
	if (bResetTimer_bob2)
		{
		bob2_StartTime = GetTickCount();
		bResetTimer_bob2 = false;
		}

	if ((GetTickCount() - bob2_StartTime) > 3000)
		{
		bResetTimer_bob2 = true;
		Critter2Ptr->state = BOB_STATE_ALIVE;
		}
	}


/*****************
COLLISION WITH ARIANA
*******************/
if((Collision_BOBS(Critter1Ptr, &Ariana) && Critter1Ptr->state == BOB_STATE_ALIVE)|| 
   (Collision_BOBS(Critter2Ptr, &Ariana) && Critter2Ptr->state == BOB_STATE_ALIVE))
	{
	explosion.x = Ariana.x-20;
	explosion.y = Ariana.y-30;
	explosion.anim_state = 0;
    DSound_Play(sound_ids[1]);
	gLifeLine--;
	}


/********************
COLLISION WITH CHEESE
*********************/
if(Collision_BOBS(&cheese1, &Ariana) && cheese1.state == BOB_STATE_ALIVE)
	{	
	cheese1.state = BOB_STATE_DEAD;
	gScore+=50;
    DSound_Play(sound_ids[3]);
	}

if(Collision_BOBS(&cheese2, &Ariana) && cheese2.state == BOB_STATE_ALIVE)
	{
	cheese2.state = BOB_STATE_DEAD;
	gScore+=50;
    DSound_Play(sound_ids[3]);
	}


/****************
RETRIEVE BABIES
*****************/
//Check for collision with babies
if (cheese1.state == BOB_STATE_DEAD && cheese2.state == BOB_STATE_DEAD)
	{

	for (std::vector<BOB*>::iterator p = vpSt_L1_FreeBabies.begin(); p != vpSt_L1_FreeBabies.end(); p++)
		{
		if(Collision_BOBS(*p, &Ariana))
			{
			pTailBaby = *p;
			vBabyChain.push_back(*p);
			vpSt_L1_FreeBabies.erase(p);						//todo this could cause a problem
			if (p == vpSt_L1_FreeBabies.end())					//patch
				break;
			}
		}
	}

//Update the position of baby chain.
if (vBabyChain.size() > 0)
	{
	//update position of first baby
/*	if (Ariana.x < vBabyChain[0]->x && Ariana.xv < 0)
		{
		vBabyChain[0]->xv = Ariana.xv;
		vBabyChain[0]->x = Ariana.x+Ariana.width;
		}
	else if (Ariana.x < vBabyChain[0]->x && Ariana.xv > 0	|| Ariana.xv == 0)
		{
		vBabyChain[0]->xv = 0;
		}
	else if (Ariana.x > vBabyChain[0]->x && Ariana.xv < 0 || Ariana.xv == 0)
		{
		vBabyChain[0]->xv = 0;
		}
	else if (Ariana.x > vBabyChain[0]->x && Ariana.xv > 0)
		{
		vBabyChain[0]->xv = Ariana.xv;
		vBabyChain[0]->x = Ariana.x - vBabyChain[0]->width;
		}
*/
	//update position of first baby
	if (Ariana.xv < 0)
		{
		vBabyChain[0]->xv = Ariana.xv;
		vBabyChain[0]->x = Ariana.x+Ariana.width;
		}
	else if (Ariana.xv > 0)
		{
		vBabyChain[0]->xv = Ariana.xv;
		vBabyChain[0]->x = Ariana.x - vBabyChain[0]->width;
		}
	else 
		{
		vBabyChain[0]->xv = Ariana.xv;
		}
	vBabyChain[0]->x+=vBabyChain[0]->xv;

	
	if((Ariana.y - vBabyChain[0]->y) > 5 || (Ariana.y - vBabyChain[0]->y) < 5)
		{
		vBabyChain[0]->y = Ariana.y;

		}
	else if((Ariana.y - vBabyChain[0]->y) < 5)
		{
		vBabyChain[0]->y = Ariana.y + 5;
		}
	else
		{
		vBabyChain[0]->y = Ariana.y - 5;
		}

	//update position of remaining babies
	if (vBabyChain.size() > 1)
		{
		std::vector<BOB*>::iterator current = &vBabyChain[1];
		std::vector<BOB*>::iterator previous= &vBabyChain[0];
		for ( ; current != vBabyChain.end(); current++)
			{
			if ((*previous)->x < (*current)->x && (*previous)->xv < 0)
				{
				(*current)->xv = (*previous)->xv;
				(*current)->x = (*previous)->x + (*previous)->width;
				}
			else if ((*previous)->x < (*current)->x && (*previous)->xv > 0	|| (*previous)->xv == 0)
				{
				(*current)->xv = 0;
				}
			else if ((*previous)->x > (*current)->x && (*previous)->xv > 0)
				{
				(*current)->xv = (*previous)->xv;
				(*current)->x = (*previous)->x - (*current)->width;
				}
			else if ((*previous)->x > (*current)->x && (*previous)->xv < 0	|| (*previous)->xv == 0)
				{
				(*current)->xv = 0;
				}
			
			(*current)->x += (*current)->xv; 
			(*current)->y = (*previous)->y;
			

			previous++;
			
			}
		}
	}//end if vBabyChain.size() >0









	return 	functionComplete;

}

void ResetLevel(LEVEL currentLevel)
{
	switch (currentLevel)
		{
		/***********************************
		*MAIN MENU
		***********************************/
		case MAIN_MENU:
			{
			}
			break; //end case MAIN_MENU

		/*************************
		*	LEVEL 1
		*************************/
		case LEVEL1:
			{
			bat1.state = BOB_STATE_ALIVE;
			bat2.state = BOB_STATE_ALIVE;
			Set_Pos_BOB(&bat1,100,70);
			Set_Pos_BOB(&bat2,100,400);


			cheese1.state = BOB_STATE_ALIVE;
			cheese2.state = BOB_STATE_ALIVE;
			
			Set_Pos_BOB(&baby1,50,90);


			apple1.xv = 0;		apple1.yv = 0;		apple1.x = 100;		apple1.y = 440;		apple1.weapon_stat = WEAPON_AVAILABLE;	
			apple2.xv = 0;		apple2.yv = 0;		apple2.x = 100;		apple2.y = 330;		apple2.weapon_stat = WEAPON_AVAILABLE;			
			apple3.xv = 0;		apple3.yv = 0;		apple3.x = 100;		apple3.y = 220;		apple3.weapon_stat = WEAPON_AVAILABLE;			
			apple4.xv = 0;		apple4.yv = 0;		apple4.x = 100;		apple4.y = 110;		apple4.weapon_stat = WEAPON_AVAILABLE;			
			apple5.xv = 0;		apple5.yv = 0;		apple5.x = 540;		apple5.y = 440;		apple5.weapon_stat = WEAPON_AVAILABLE;			
			apple6.xv = 0;		apple6.yv = 0;		apple6.x = 540;		apple6.y = 330;		apple6.weapon_stat = WEAPON_AVAILABLE;			
			apple7.xv = 0;		apple7.yv = 0;		apple7.x = 540;		apple7.y = 220;		apple7.weapon_stat = WEAPON_AVAILABLE;			
			apple8.xv = 0;		apple8.yv = 0;		apple8.x = 540;		apple8.y = 110;		apple8.weapon_stat = WEAPON_AVAILABLE;			

			for (std::vector<BOB*>::iterator i = vpSt_L1_Weapons.begin(); i != vpSt_L1_Weapons.end(); i++)
				{
				(*i)->weapon_stat = WEAPON_AVAILABLE;
				}

			vActiveProjectile.clear();
			vBabyChain.clear();
			int n = vBabyChain.size();
			vpSt_L1_FreeBabies.push_back(aLevel1_babies[0]);
			x_offset = 0;
			Ariana.x = 320;
			Set_Pos_BOB(&baby1,530,200);

			}
			break;

		/*************************
		*	LEVEL 2
		*************************/
		case LEVEL2:
			{

			}
			break;

		/*********************************
		*	LEVEL GAME OVER SPLASH SCREEN
		*********************************/
		case GAME_OVER:
			{

			}
			break;

		/*************************
		*	CONGRATULATIONS
		*************************/
		case CONGRATULATIONS:
			{

			}
			break;

		/*************************
		*	CREDITS
		*************************/
		case CREDITS:
			{

			}
			break;

		default:
			break;
		}

	return;


}

inline void DrawInViewPort(BOB* bob_ptr, int x_offset)
{
	if (x_offset == 0)
		{
		Draw_BOB16(bob_ptr,lpddsback);
		}
	else if ( x_offset > 0)
		{
		Draw_BOB16(bob_ptr,lpddsback, x_offset);
		Draw_BOB16(bob_ptr,lpddsback, x_offset- SCREEN_WIDTH);		//alias
		}
	else //offset < 0
		{

		Draw_BOB16(bob_ptr,lpddsback, x_offset);
		Draw_BOB16(bob_ptr,lpddsback, x_offset+ SCREEN_WIDTH);		//alias
		}

	return;
	
	
}



